Index: .hgsub
===================================================================
--- .hgsub	(revision 0)
+++ .hgsub	(revision 786)
@@ -1,1 +1,1 @@
-inc/libs/clearbricks = https://bitbucket.org/dotclear/clearbricks
+inc/libs/clearbricks = https://clearbricks.org/hg
Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 782)
+++ .hgsubstate	(revision 843)
@@ -1,1 +1,1 @@
-cf8874ccc1fae0e9315d461497ff019f6dafeb7f inc/libs/clearbricks
+4f62679e0756104bdc0b49eacaed9aba68735aa5 inc/libs/clearbricks
Index: .hgtags
===================================================================
--- .hgtags	(revision 369)
+++ .hgtags	(revision 800)
@@ -1,2 +1,7 @@
 ec077f3c6b20bc6f7f40a113acaff0220457a2c4 2.3.0
 4e0137ddb12474d62b88c4966d5895a391b6d382 2.3.1
+43a9cace0f39c95463e66346dcc953ced40836be 2.4.2
+43a9cace0f39c95463e66346dcc953ced40836be 2.4.2
+0000000000000000000000000000000000000000 2.4.2
+0000000000000000000000000000000000000000 2.4.2
+6b3942c0cf7eee71ebd906ec0827c5962823dedf 2.4.2
Index: CHANGELOG
===================================================================
--- CHANGELOG	(revision 777)
+++ CHANGELOG	(revision 824)
@@ -1,12 +1,27 @@
-Dotclear 2.4.1-dev
-===========================================================
-* New behavior : publicGetURLFor
-* New behavior : publicRegisterURL
-* New behavior : templatePrepareParams
+Dotclear 2.4.3 - 2012-05-18
+===========================================================
+* Admin: My favorites menu can be hidden
+* Admin: Fix wordpress importer
+* Admin: about:config and user:pref tables are now more readable
+* Ductile theme: Blog logo can be changed
+* New lithuanian language (thanks to Paulius Černakauskas)
+* Various bug fixes
+
+Dotclear 2.4.2 - 2012-02-11
+===========================================================
+* Security fix release
+* 4 XSS vulnerabilities fixed, discovered by High-Tech Bridge
+
+Dotclear 2.4.1.2 - 2011-12-24
+===========================================================
+* Happy Christmas!
+* Security: fixed one SQL injection vulnerability in Clearbricks, thanks to Adjaya
+* New behaviour: publicGetURLFor
+* New behaviour: publicRegisterURL
+* New behaviour: templatePrepareParams
 * Changed the way to get artefacts URLs, through $core->url->getURLFor calls, instead of $core->url->getBase()
 * new/updated parameter sql_only in $core->blog->getPosts and $core->blog->getComments
 
-
-Dotclear 2.4.0
+Dotclear 2.4.0 - 2011-11-13
 ===========================================================
 * Admin: new iconset from Thomas Daveluy
@@ -21,5 +36,5 @@
 * Various bug fixes
 
-Dotclear 2.3.1 - 2001-06-14
+Dotclear 2.3.1 - 2011-06-14
 ===========================================================
 * Updated makefile for cleaner distrib.
Index: admin/auth.php
===================================================================
--- admin/auth.php	(revision 550)
+++ admin/auth.php	(revision 794)
@@ -31,5 +31,5 @@
 
 $change_pwd = $core->auth->allowPassChange() && isset($_POST['new_pwd']) && isset($_POST['new_pwd_c']) && isset($_POST['login_data']);
-$login_data = !empty($_POST['login_data']) ? $_POST['login_data'] : null;
+$login_data = !empty($_POST['login_data']) ? html::escapeHTML($_POST['login_data']) : null;
 $recover = $core->auth->allowPassChange() && !empty($_REQUEST['recover']);
 $safe_mode = !empty($_REQUEST['safe_mode']);
Index: admin/blog_pref.php
===================================================================
--- admin/blog_pref.php	(revision 557)
+++ admin/blog_pref.php	(revision 887)
@@ -98,4 +98,20 @@
 	$img_title_combo[html::escapeHTML($blog_settings->system->media_img_title_pattern)] = html::escapeHTML($blog_settings->system->media_img_title_pattern);
 }
+
+# Image default size combo
+$img_default_size_combo = array();
+$media = new dcMedia($core);
+$img_default_size_combo[__('original')] = 'o';
+foreach ($media->thumb_sizes as $code => $size) {
+	$img_default_size_combo[__($size[2])] = $code;
+}
+
+# Image default alignment combo
+$img_default_alignment_combo = array(
+	__('None') => 'none',
+	__('Left') => 'left',
+	__('Right') => 'right',
+	__('Center') => 'center'
+);
 
 # Robots policy options
@@ -198,4 +214,7 @@
 		$blog_settings->system->put('media_img_m_size',$media_img_m_size);
 		$blog_settings->system->put('media_img_title_pattern',$_POST['media_img_title_pattern']);
+		$blog_settings->system->put('media_img_default_size',$_POST['media_img_default_size']);
+		$blog_settings->system->put('media_img_default_alignment',$_POST['media_img_default_alignment']);
+		$blog_settings->system->put('media_img_default_link',!empty($_POST['media_img_default_link']));
 		$blog_settings->system->put('nb_post_per_feed',$nb_post_per_feed);
 		$blog_settings->system->put('nb_comment_per_feed',$nb_comment_per_feed);
@@ -431,5 +450,20 @@
 	'<p>'.form::combo('media_img_title_pattern',$img_title_combo,html::escapeHTML($blog_settings->system->media_img_title_pattern)).'</p>'.
 	'</div>'.
-	'</div>'.
+
+	'<div class="col">'.
+	'<h4>'.__('Default image insertion attributes').'</h4>'.
+	'<p><label for="media_img_default_size">'.__('Image size:').
+	form::combo('media_img_default_size',$img_default_size_combo,
+		(html::escapeHTML($blog_settings->system->media_img_default_size) != '' ? html::escapeHTML($blog_settings->system->media_img_default_size) : 'm')).
+	'</label></p>'.
+	'<p><label for="media_img_default_alignment">'.__('Image alignment').
+	form::combo('media_img_default_alignment',$img_default_alignment_combo,html::escapeHTML($blog_settings->system->media_img_default_alignment)).
+	'</label></p>'.
+	'<p><label for="media_img_default_link" class="classic">'.
+	form::checkbox('media_img_default_link','1',$blog_settings->system->media_img_default_link).
+	__('As a link to original image').'</label></p>'.
+	'</div>'.
+	'</div>'.
+
 	'</fieldset>';
 	
@@ -523,13 +557,5 @@
 				' ('.html::escapeHTML(dcUtils::getUserCN(
 					$k, $v['name'], $v['firstname'], $v['displayname']
-				)).')';
-				
-				if (!$v['super'] && $core->auth->isSuperAdmin()) {
-					echo
-					' - <a href="permissions.php?blog_id[]='.$blog_id.'&amp;user_id[]='.$k.'">'
-					.__('Change permissions').'</a>';
-				}
-				
-				echo '</h4>';
+				)).')</h4>';
 				
 				echo '<ul>';
@@ -542,4 +568,17 @@
 				}
 				echo '</ul>';
+				
+				if (!$v['super'] && $core->auth->isSuperAdmin()) {
+					echo 
+					'<form action="users_actions.php" method="post">'.
+					'<p><input type="submit" value="'.__('Change permissions').'" />'.
+					form::hidden(array('redir'),'blog_pref.php?id='.$k).
+					form::hidden(array('action'),'perms').
+					form::hidden(array('users[]'),$k).
+					form::hidden(array('blogs[]'),$blog_id).
+					$core->formNonce().
+					'</p>'.
+					'</form>';
+				}
 			}
 		}
Index: admin/blogs.php
===================================================================
--- admin/blogs.php	(revision 782)
+++ admin/blogs.php	(revision 792)
@@ -15,12 +15,26 @@
 dcPage::check('usage,contentadmin');
 
+# Filters
+$sortby_combo = array(
+__('Last update') => 'blog_upddt',
+__('Blog name') => 'UPPER(blog_name)',
+__('Blog ID') => 'B.blog_id'
+);
+
+$order_combo = array(
+__('Descending') => 'desc',
+__('Ascending') => 'asc'
+);
+
 $q = !empty($_GET['q']) ? $_GET['q'] : '';
+$sortby = !empty($_GET['sortby']) ? $_GET['sortby'] : 'blog_upddt';
+$order = !empty($_GET['order']) ? $_GET['order'] : 'desc';
 
-$blogs_list = new adminBlogList($core);
+$page = !empty($_GET['page']) ? $_GET['page'] : 1;
+$nb_per_page =  30;
 
-$params = new ArrayObject();
-
-# - Limit, sortby and order filter
-$params = $blogs_list->applyFilters($params);
+if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
+	$nb_per_page = (integer) $_GET['nb'];
+}
 
 $show_filters = false;
@@ -32,8 +46,21 @@
 }
 
+# - Sortby and order filter
+if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
+	if ($order !== '' && in_array($order,$order_combo)) {
+		$params['order'] = $sortby.' '.$order;
+	}
+	
+	if ($sortby != 'blog_upddt' || $order != 'desc') {
+		$show_filters = true;
+	}
+}
+
+$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
+
 try {
 	$counter = $core->getBlogs($params,1);
 	$rs = $core->getBlogs($params);
-	$blogs_list->setItems($rs,$counter->f(0));
+	$nb_blog = $counter->f(0);
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
@@ -66,10 +93,23 @@
 	echo
 	'<form action="blogs.php" method="get" id="filters-form">'.
-	'<fieldset><legend>'.__('Filters').'</legend>'.
+	'<fieldset class="two-cols"><legend>'.__('Filters').'</legend>'.
 	
+	'<div class="col">'.
+	'<p><label for="sortby">'.__('Order by:').' '.
+	form::combo('sortby',$sortby_combo,html::escapeHTML($sortby)).
+	'</label> '.
+	'<label for="order">'.__('Sort:').' '.
+	form::combo('order',$order_combo,html::escapeHTML($order)).
+	'</label></p>'.
+	'</div>'.
+	
+	'<div class="col">'.
 	'<p><label for="q">'.__('Search:').' '.
 	form::field('q',20,255,html::escapeHTML($q)).
 	'</label></p>'.
-	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
+	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
+	__('Blogs per page').'</label> '.
+	'<input type="submit" value="'.__('Apply filters').'" /></p>'.
+	'</div>'.
 	
 	'<br class="clear" />'. //Opera sucks
@@ -78,8 +118,68 @@
 	
 	# Show blogs
-	$blogs_list->display();
+	if ($nb_blog == 0)
+	{
+		echo '<p><strong>'.__('No blog').'</strong></p>';
+	}
+	else
+	{
+		$pager = new pager($page,$nb_blog,$nb_per_page,10);
+		$pager->var_page = 'page';
+		
+		echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+		
+		echo
+		'<table class="clear"><tr>'.
+		'<th>'.__('Blog name').'</th>'.
+		'<th class="nowrap">'.__('Last update').'</th>'.
+		'<th class="nowrap">'.__('Entries').'</th>'.
+		'<th class="nowrap">'.__('Blog ID').'</th>'.
+		'<th>&nbsp;</th>'.
+		'<th class="nowrap">'.__('Status').'</th>'.
+		'</tr>';
+		
+		while ($rs->fetch()) {
+			echo blogLine($rs);
+		}
+		
+		echo '</table>';
+		
+		echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+	}
 }
 
 dcPage::close();
 
+function blogLine($rs)
+{
+	global $core;
+	
+	$blog_id = html::escapeHTML($rs->blog_id);
+	$edit_link = '';
+	
+	if ($GLOBALS['core']->auth->isSuperAdmin()) {
+		$edit_link = 
+		'<a href="blog.php?id='.$blog_id.'" '.
+		'title="'.sprintf(__('Edit blog %s'),$blog_id).'">'.
+		__('edit').'</a>';
+	}
+	
+	$img_status = $rs->blog_status == 1 ? 'check-on' : 'check-off';
+	$txt_status = $GLOBALS['core']->getBlogStatus($rs->blog_status);
+	$img_status = sprintf('<img src="images/%1$s.png" alt="%2$s" title="%2$s" />',$img_status,$txt_status);
+	$offset = dt::getTimeOffset($core->auth->getInfo('user_tz'));
+	$blog_upddt = dt::str(__('%Y-%m-%d %H:%M'),strtotime($rs->blog_upddt) + $offset);
+	
+	return
+	'<tr class="line">'.
+	'<td class="maximal"><a href="index.php?switchblog='.$rs->blog_id.'" '.
+	'title="'.sprintf(__('Switch to blog %s'),$rs->blog_id).'">'.
+	html::escapeHTML($rs->blog_name).'</a></td>'.
+	'<td class="nowrap">'.$blog_upddt.'</td>'.
+	'<td class="nowrap">'.$core->countBlogPosts($rs->blog_id).'</td>'.
+	'<td class="nowrap">'.$blog_id.'</td>'.
+	'<td>'.$edit_link.'</td>'.
+	'<td class="status">'.$img_status.'</td>'.
+	'</tr>';
+}
 ?>
Index: admin/comments.php
===================================================================
--- admin/comments.php	(revision 783)
+++ admin/comments.php	(revision 796)
@@ -15,21 +15,9 @@
 dcPage::check('usage,contentadmin');
 
-class authorFilter extends textFilter {
-	public function header() {
-		return 
-			dcPage::jqueryUI().
-			dcPage::jsLoad('js/author_filter.js')
-			;
-	}
-	public function applyFilter($params) {
-		$val = preg_split('/\s*,\s*/',$this->values[0]);
-		$params[$this->request_param]=$val;
-	}
-}
-
-
 # Creating filter combo boxes
 # Filter form we'll put in html_block
-$status_combo = array();
+$status_combo = array(
+'-' => ''
+);
 foreach ($core->blog->getAllCommentStatus() as $k => $v) {
 	$status_combo[$v] = (string) $k;
@@ -37,17 +25,100 @@
 
 $type_combo = array(
-__('comment') => '0',
-__('trackback') => '1'
-);
-
-$comment_list = new adminCommentList($core);
-
-$params = new ArrayObject();
+'-' => '',
+__('comment') => 'co',
+__('trackback') => 'tb'
+);
+
+$sortby_combo = array(
+__('Date') => 'comment_dt',
+__('Entry title') => 'post_title',
+__('Author') => 'comment_author',
+__('Status') => 'comment_status'
+);
+
+$order_combo = array(
+__('Descending') => 'desc',
+__('Ascending') => 'asc'
+);
+
+
+/* Get comments
+-------------------------------------------------------- */
+$author = isset($_GET['author']) ?	$_GET['author'] : '';
+$status = isset($_GET['status']) ?		$_GET['status'] : '';
+$type = !empty($_GET['type']) ?		$_GET['type'] : '';
+$sortby = !empty($_GET['sortby']) ?	$_GET['sortby'] : 'comment_dt';
+$order = !empty($_GET['order']) ?		$_GET['order'] : 'desc';
+$ip = !empty($_GET['ip']) ?			$_GET['ip'] : '';
+
+$with_spam = $author || $status || $type || $sortby != 'comment_dt' || $order != 'desc' || $ip;
+
+$show_filters = false;
+
+$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
+$nb_per_page =  30;
+
+if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
+	if ($nb_per_page != $_GET['nb']) {
+		$show_filters = true;
+	}
+	$nb_per_page = (integer) $_GET['nb'];
+}
+
+$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
 $params['no_content'] = true;
 
-# - Limit, sortby and order filter
+# Author filter
+if ($author !== '') {
+	$params['q_author'] = $author;
+	$show_filters = true;
+} else {
+	$author='';
+}
+
+# - Type filter
+if ($type == 'tb' || $type == 'co') {
+	$params['comment_trackback'] = ($type == 'tb');
+	$show_filters = true;
+} else {
+	$type='';
+}
+
+# - Status filter
+if ($status !== '' && in_array($status,$status_combo)) {
+	$params['comment_status'] = $status;
+	$show_filters = true;
+} elseif (!$with_spam) {
+	$params['comment_status_not'] = -2;
+	$status='';
+} else {
+	$status='';
+}
+
+# - IP filter
+if ($ip) {
+	$params['comment_ip'] = $ip;
+	$show_filters = true;
+}
+
+# Sortby and order filter
+if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
+	if ($order !== '' && in_array($order,$order_combo)) {
+		$params['order'] = $sortby.' '.$order;
+	} else {
+		$order = 'desc';
+	}
+	
+	if ($sortby != 'comment_dt' || $order != 'desc') {
+		$show_filters = true;
+	}
+} else {
+	$sortby = 'comment_dt';
+	$order = 'desc';
+}
 
 # Actions combo box
 $combo_action = array();
+$default = '';
 if ($core->auth->check('publish,contentadmin',$core->blog->id))
 {
@@ -59,5 +130,8 @@
 if ($core->auth->check('delete,contentadmin',$core->blog->id))
 {
-	$combo_action[__('delete')] = 'delete';
+	$combo_action[__('Delete')] = 'delete';
+	if ($status == -2) {
+		$default = 'delete';
+	}
 }
 
@@ -65,42 +139,10 @@
 $core->callBehavior('adminCommentsActionsCombo',array(&$combo_action));
 
-$filterSet = new dcFilterSet('comments','comments.php');
-
-$authorFilter = new authorFilter(
-		'author',__('Author'), __('Author'),'comment_author',20,255);
-$filterSet
-	->addFilter(new comboFilter(
-		'status',__('Status'), __('Status'), 'comment_status', $status_combo))
-	->addFilter(new booleanFilter(
-		'type',__('Type'), __('Type'), 'comment_trackback', $type_combo))
-	->addFilter($authorFilter)
-	->addFilter(new textFilter(
-		'ip',__('IP address'), __('IP address'), 'comment_ip',20,39));
-		
-$core->callBehavior('adminCommentsFilters',$filterSet);
-$filterSet->setExtra($comment_list);
-
-$filterSet->setup($_GET,$_POST);
-if (isset($_GET['author'])) {
-	$authorFilter->add();
-	$authorFilter->setValues($_GET['author']);
-}
-$with_spam=true;
 /* Get comments
 -------------------------------------------------------- */
 try {
-	$nfparams = $params->getArrayCopy();
-	$filtered = $filterSet->applyFilters($params);
-	$core->callBehavior('adminCommentsParams',$params);
 	$comments = $core->blog->getComments($params);
 	$counter = $core->blog->getComments($params,true);
-	if ($filtered) {
-		$totalcounter = $core->blog->getComments($nfparams,true);
-		$page_title = sprintf(__('Comments and Trackacks / %s filtered out of %s'),$counter->f(0),$totalcounter->f(0));
-	} else {
-		$page_title = __('Comments and Trackacks');
-	}
-
-	$comment_list->setItems($comments,$counter->f(0));
+	$comment_list = new adminCommentList($core,$comments,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
@@ -109,6 +151,8 @@
 /* DISPLAY
 -------------------------------------------------------- */
-$starting_script = dcPage::jsLoad('js/_comments.js').$filterSet->header();
-
+$starting_script = dcPage::jsLoad('js/_comments.js');
+if (!$show_filters) {
+	$starting_script .= dcPage::jsLoad('js/filter-controls.js');
+}
 # --BEHAVIOR-- adminCommentsHeaders
 $starting_script .= $core->callBehavior('adminCommentsHeaders');
@@ -121,5 +165,47 @@
 {
 	# Filters
-	$filterSet->display();
+	if (!$show_filters) {
+		echo '<p><a id="filter-control" class="form-control" href="#">'.
+		__('Filters').'</a></p>';
+	}
+	
+	echo
+	'<form action="comments.php" method="get" id="filters-form">'.
+	'<fieldset><legend>'.__('Filters').'</legend>'.
+	'<div class="three-cols">'.
+	'<div class="col">'.
+	'<label for="type">'.__('Type:').' '.
+	form::combo('type',$type_combo,$type).
+	'</label> '.
+	'<label for="status">'.__('Status:').' '.
+	form::combo('status',$status_combo,$status).
+	'</label>'.
+	'</div>'.
+	
+	'<div class="col">'.
+	'<p><label for="sortby">'.__('Order by:').' '.
+	form::combo('sortby',$sortby_combo,$sortby).
+	'</label> '.
+	'<label for="order">'.__('Sort:').' '.
+	form::combo('order',$order_combo,$order).
+	'</label></p>'.
+	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
+	__('Comments per page').'</label></p>'.
+	'</div>'.
+	
+	'<div class="col">'.
+	'<p><label for="author">'.__('Comment author:').' '.
+	form::field('author',20,255,html::escapeHTML($author)).
+	'</label>'.
+	'<label for="ip">'.__('IP address:').' '.
+	form::field('ip',20,39,html::escapeHTML($ip)).
+	'</label></p>'.
+	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
+	'</div>'.
+	
+	'</div>'.
+	'<br class="clear" />'. //Opera sucks
+	'</fieldset>'.
+	'</form>';
 	
 	if (!$with_spam) {
@@ -135,5 +221,6 @@
 	
 	# Show comments
-	$comment_list->display('<form action="comments_actions.php" method="post" id="form-comments">'.
+	$comment_list->display($page,$nb_per_page,
+	'<form action="comments_actions.php" method="post" id="form-comments">'.
 	
 	'%s'.
@@ -143,8 +230,15 @@
 	
 	'<p class="col right"><label for="action" class="classic">'.__('Selected comments action:').'</label> '.
-	form::combo('action',$combo_action,'','','','','title="'.__('action: ').'"').
+	form::combo('action',$combo_action,$default,'','','','title="'.__('action: ').'"').
 	$core->formNonce().
 	'<input type="submit" value="'.__('ok').'" /></p>'.
-	str_replace('%','%%',$filterSet->getFormFieldsAsHidden()).
+	form::hidden(array('type'),$type).
+	form::hidden(array('sortby'),$sortby).
+	form::hidden(array('order'),$order).
+	form::hidden(array('author'),preg_replace('/%/','%%',$author)).
+	form::hidden(array('status'),$status).
+	form::hidden(array('ip'),preg_replace('/%/','%%',$ip)).
+	form::hidden(array('page'),$page).
+	form::hidden(array('nb'),$nb_per_page).
 	'</div>'.
 	
Index: admin/comments_actions.php
===================================================================
--- admin/comments_actions.php	(revision 782)
+++ admin/comments_actions.php	(revision 270)
@@ -30,5 +30,12 @@
 	{
 		$redir =
-		'comments.php?'.urldecode($_POST['f_query']);
+		'comments.php?type='.$_POST['type'].
+		'&author='.$_POST['author'].
+		'&status='.$_POST['status'].
+		'&sortby='.$_POST['sortby'].
+		'&ip='.$_POST['ip'].
+		'&order='.$_POST['order'].
+		'&page='.$_POST['page'].
+		'&nb='.(integer) $_POST['nb'];
 	}
 	
Index: admin/install/wizard.php
===================================================================
--- admin/install/wizard.php	(revision 557)
+++ admin/install/wizard.php	(revision 858)
@@ -44,4 +44,13 @@
 if (is_file(DC_RC_PATH)) {
 	http::redirect('index.php');
+}
+
+if (!is_writable(dirname(DC_RC_PATH))) {
+	$err = '<p>'.sprintf(__('Path <strong>%s</strong> is not writable.'),path::real(dirname(DC_RC_PATH))).'</p>'.
+	'<p>'.__('Dotclear installation wizard could not create configuration file for you. '.
+		'You must change folder right or create the <strong>config.php</strong> '.
+		'file manually, please refer to '.
+		'<a href="http://dotclear.org/documentation/2.0/admin/install">'.
+		'the documentation</a> to learn how to do this.').'</p>';
 }
 
Index: admin/js/_users.js
===================================================================
--- admin/js/_users.js	(revision 548)
+++ admin/js/_users.js	(revision 860)
@@ -4,5 +4,5 @@
 	});
 	$('#form-users').submit(function() {
-		var action = $(this).find('select[name="dispatch_action"]').val();
+		var action = $(this).find('select[name="action"]').val();
 		var user_ids = new Array();
 		var nb_posts = new Array();
@@ -10,5 +10,5 @@
 		var msg_cannot_delete = false;
 		
-		$(this).find('input[name="user_id[]"]').each(function() {
+		$(this).find('input[name="users[]"]').each(function() {
 			user_ids.push(this);
 		});
@@ -41,5 +41,5 @@
 		
 		if (action == 'deleteuser') {
-			return window.confirm(dotclear.msg.confirm_delete_user.replace('%s',$('input[name="user_id[]"]:checked').size()));
+			return window.confirm(dotclear.msg.confirm_delete_user.replace('%s',$('input[name="users[]"]:checked').size()));
 		}
 		
Index: admin/js/_users_actions.js
===================================================================
--- admin/js/_users_actions.js	(revision 860)
+++ admin/js/_users_actions.js	(revision 860)
@@ -0,0 +1,59 @@
+jQuery.fn.updatePermissionsForm = function() {
+	return this.each(function() {
+		var perms = {};
+		var re = /^perm\[(.+?)\]\[(.+?)\]$/;
+		var e,prop;
+		
+		// Building a nice object of form elements
+		for (var i=0; i<this.elements.length; i++) {
+			e = this.elements[i];
+			
+			if (e.name == undefined) {
+				continue;
+			}
+			prop = e.name.match(re);
+			if (!prop) {
+				continue;
+			}
+			if (perms[prop[1]] == undefined) {
+				perms[prop[1]] = {};
+			}
+			perms[prop[1]][prop[2]] = e;
+		}
+		
+		// Update elements status
+		var E;
+		for (blog in perms) {
+			for (perm in perms[blog]) {
+				E = perms[blog][perm];
+				E.onclick = function() {};
+				
+				if (perm == 'admin' && !E.disabled) {
+					perms[blog]['usage'].disabled = E.checked;
+					perms[blog]['publish'].disabled = E.checked;
+					perms[blog]['delete'].disabled = E.checked;
+					perms[blog]['contentadmin'].disabled = E.checked;
+					perms[blog]['categories'].disabled = E.checked;
+					perms[blog]['media'].disabled = E.checked;
+					perms[blog]['media_admin'].disabled = E.checked;
+					E.onclick = function() { $(this.form).updatePermissionsForm(); };
+				} else if (perm == 'contentadmin' && !E.disabled) {
+					perms[blog]['usage'].disabled = E.checked;
+					perms[blog]['publish'].disabled = E.checked;
+					perms[blog]['delete'].disabled = E.checked;
+					E.onclick = function() { $(this.form).updatePermissionsForm(); };
+				} else if (perm == 'media_admin' && !E.disabled) {
+					perms[blog]['media'].disabled = E.checked;
+					E.onclick = function() { $(this.form).updatePermissionsForm(); };
+				}
+			}
+		}
+	});
+};
+
+$(function() {
+	$('.checkboxes-helpers').each(function() {
+		dotclear.checkboxesHelpers(this);
+	});
+	$('#permissions-form').updatePermissionsForm();
+});
Index: admin/langs.php
===================================================================
--- admin/langs.php	(revision 782)
+++ admin/langs.php	(revision 500)
@@ -173,10 +173,8 @@
 {
 	echo
-	'<table class="clear plugins">'.
-	'<thead><tr>'.
-	'<th scope="col">'.__('Language').'</th>'.
-	'<th scope="col" class="nowrap">'.__('Action').'</th>'.
-	'</tr></thead>'.
-	'<tbody>';
+	'<table class="clear plugins"><tr>'.
+	'<th>'.__('Language').'</th>'.
+	'<th class="nowrap">'.__('Action').'</th>'.
+	'</tr>';
 	
 	foreach ($locales_content as $k => $v)
@@ -186,6 +184,6 @@
 		echo
 		'<tr class="line wide">'.
-		'<th scope="row" class="maximal nowrap">('.$k.') '.
-		'<strong>'.html::escapeHTML($iso_codes[$k]).'</strong></th>'.
+		'<td class="maximal nowrap">('.$k.') '.
+		'<strong>'.html::escapeHTML($iso_codes[$k]).'</strong></td>'.
 		'<td class="nowrap action">';
 		
@@ -204,7 +202,5 @@
 		echo '</td></tr>';
 	}
-	echo
-	'</tbody>'.
-	'</table>';
+	echo '</table>';
 }
 
@@ -232,5 +228,5 @@
 	'Proposed languages are based on your version: %s.'),'<strong>'.DC_VERSION.'</strong>').'</p>'.
 	'<p class="field"><label for="pkg_url" class="classic">'.__('Language:').' '.
-	form::combo('pkg_url',$dc_langs_combo).'</label></p>'.
+	form::combo(array('pkg_url'),$dc_langs_combo).'</label></p>'.
 	'<p class="field"><label for="your_pwd1" class="classic required"><abbr title="'.__('Required field').'">*</abbr> '.__('Your password:').' '.
 	form::password(array('your_pwd','your_pwd1'),20,255).'</label></p>'.
Index: admin/media_item.php
===================================================================
--- admin/media_item.php	(revision 663)
+++ admin/media_item.php	(revision 887)
@@ -15,4 +15,6 @@
 dcPage::check('media,media_admin');
 
+$tab = empty($_REQUEST['tab']) ? '' : $_REQUEST['tab'];
+
 $post_id = !empty($_GET['post_id']) ? (integer) $_GET['post_id'] : null;
 if ($post_id) {
@@ -103,5 +105,5 @@
 	try {
 		$core->media->updateFile($file,$newFile);
-		http::redirect($page_url.'&id='.$id.'&fupd=1');
+		http::redirect($page_url.'&id='.$id.'&fupd=1&tab=media-details-tab');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -115,5 +117,5 @@
 		$foo = null;
 		$core->media->mediaFireRecreateEvent($file);
-		http::redirect($page_url.'&id='.$id.'&thumbupd=1');
+		http::redirect($page_url.'&id='.$id.'&thumbupd=1&tab=media-details-tab');
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
@@ -165,5 +167,5 @@
 	$starting_scripts.
 	dcPage::jsDatePicker().
-	dcPage::jsPageTabs()
+	dcPage::jsPageTabs($tab)
 );
 
@@ -200,5 +202,15 @@
 			$media_desc = '';
 		}
-		
+
+		$media_img_default_size = $core->blog->settings->system->media_img_default_size;
+		if ($media_img_default_size == '') {
+			$media_img_default_size = 'm';
+		}
+		$media_img_default_alignment = $core->blog->settings->system->media_img_default_alignment;
+		if ($media_img_default_alignment == '') {
+			$media_img_default_alignment = 'none';
+		}
+		$media_img_default_link = (boolean)$core->blog->settings->system->media_img_default_link;
+
 		echo
 		'<h3>'.__('Image size:').'</h3> ';
@@ -207,10 +219,10 @@
 		echo '<p>';
 		foreach (array_reverse($file->media_thumb) as $s => $v) {
-			$s_checked = ($s == 'm');
+			$s_checked = ($s == $media_img_default_size);
 			echo '<label class="classic">'.
 			form::radio(array('src'),html::escapeHTML($v),$s_checked).' '.
 			$core->media->thumb_sizes[$s][2].'</label><br /> ';
 		}
-		$s_checked = (!isset($file->media_thumb['m']));
+		$s_checked = (!isset($file->media_thumb[$media_img_default_size]));
 		echo '<label class="classic">'.
 		form::radio(array('src'),$file->file_url,$s_checked).' '.__('original').'</label><br /> ';
@@ -220,8 +232,8 @@
 		echo '<h3>'.__('Image alignment').'</h3>';
 		$i_align = array(
-			'none' => array(__('None'),1),
-			'left' => array(__('Left'),0),
-			'right' => array(__('Right'),0),
-			'center' => array(__('Center'),0)
+			'none' => array(__('None'),($media_img_default_alignment == 'none' ? 1 : 0)),
+			'left' => array(__('Left'),($media_img_default_alignment == 'left' ? 1 : 0)),
+			'right' => array(__('Right'),($media_img_default_alignment == 'right' ? 1 : 0)),
+			'center' => array(__('Center'),($media_img_default_alignment == 'center' ? 1 : 0))
 		);
 		
@@ -236,7 +248,7 @@
 		'<h3>'.__('Image insertion').'</h3>'.
 		'<p>'.
-		'<label for="insert1" class="classic">'.form::radio(array('insertion','insert1'),'simple',true).
+		'<label for="insert1" class="classic">'.form::radio(array('insertion','insert1'),'simple',!$media_img_default_link).
 		__('As a single image').'</label><br />'.
-		'<label for="insert2" class="classic">'.form::radio(array('insertion','insert2'),'link',false).
+		'<label for="insert2" class="classic">'.form::radio(array('insertion','insert2'),'link',$media_img_default_link).
 		__('As a link to original image').'</label>'.
 		'</p>';
@@ -340,7 +352,7 @@
 		$strong_link = ($s == $thumb_size) ? '<strong>%s</strong>' : '%s';
 		printf($strong_link,'<a href="'.html::escapeURL($page_url).
-		'&amp;id='.$id.'&amp;size='.$s.'">'.$core->media->thumb_sizes[$s][2].'</a> | ');
-	}
-	echo '<a href="'.html::escapeURL($page_url).'&amp;id='.$id.'&amp;size=o">'.__('original').'</a>';
+		'&amp;id='.$id.'&amp;size='.$s.'&amp;tab=media-details-tab">'.$core->media->thumb_sizes[$s][2].'</a> | ');
+	}
+	echo '<a href="'.html::escapeURL($page_url).'&amp;id='.$id.'&amp;size=o&amp;tab=media-details-tab">'.__('original').'</a>';
 	echo '</p>';
 	
@@ -377,5 +389,5 @@
 {
 	echo
-	'<p><strong><a href="'.html::escapeHTML($page_url).'&amp;id='.$id.'&amp;find_posts=1">'.
+	'<p><strong><a href="'.html::escapeHTML($page_url).'&amp;id='.$id.'&amp;find_posts=1&amp;tab=media-details-tab">'.
 	__('Show entries containing this media').'</a></strong></p>';
 }
Index: admin/plugins.php
===================================================================
--- admin/plugins.php	(revision 782)
+++ admin/plugins.php	(revision 500)
@@ -227,13 +227,10 @@
 	echo
 	'<h3>'.__('Activated plugins').'</h3>'.
-	'<table class="clear plugins">'.
-	'<caption>'.__('Activated plugin list').'</caption>'.
-	'<thead><tr>'.
-	'<th scope="col">'.__('Plugin').'</th>'.
-	'<th scope="col" class="nowrap">'.__('Version').'</th>'.
-	'<th scope="col" class="nowrap">'.__('Details').'</th>'.
-	'<th scope="col" class="nowrap">'.__('Action').'</th>'.
-	'</tr></thead>'.
-	'<tbody>';
+	'<table class="clear plugins"><tr>'.
+	'<th>'.__('Plugin').'</th>'.
+	'<th class="nowrap">'.__('Version').'</th>'.
+	'<th class="nowrap">'.__('Details').'</th>'.
+	'<th class="nowrap">'.__('Action').'</th>'.
+	'</tr>';
 	
 	foreach ($p_available as $k => $v)
@@ -244,5 +241,5 @@
 		echo
 		'<tr class="line wide">'.
-		'<th scope="row" class="minimal nowrap"><strong>'.html::escapeHTML($k).'</strong></th>'.
+		'<td class="minimal nowrap"><strong>'.html::escapeHTML($k).'</strong></td>'.
 		'<td class="minimal">'.html::escapeHTML($v['version']).'</td>'.
 		'<td class="maximal"><strong>'.html::escapeHTML($v['name']).'</strong> '.
@@ -268,5 +265,4 @@
 	}
 	echo
-	'</tbody>'.
 	'</table>';
 }
@@ -278,11 +274,8 @@
 	echo
 	'<h3>'.__('Deactivated plugins').'</h3>'.
-	'<table class="clear plugins">'.
-	'<caption>'.__('Deactivated plugin list').'</caption>'.
-	'<thead><tr>'.
-	'<th scope="col">'.__('Plugin').'</th>'.
-	'<th scope="col" class="nowrap">'.__('Action').'</th>'.
-	'</tr></thead>'.
-	'<tbody>';
+	'<table class="clear plugins"><tr>'.
+	'<th>'.__('Plugin').'</th>'.
+	'<th class="nowrap">'.__('Action').'</th>'.
+	'</tr>';
 	
 	foreach ($p_disabled as $k => $v)
@@ -293,5 +286,5 @@
 		echo
 		'<tr class="line wide">'.
-		'<th scope="row" class="maximal nowrap"><strong>'.html::escapeHTML($k).'</strong></th>'.
+		'<td class="maximal nowrap"><strong>'.html::escapeHTML($k).'</strong></td>'.
 		'<td class="nowrap action">';
 		
@@ -315,5 +308,4 @@
 	}
 	echo
-	'</tbody>'.
 	'</table>';
 }
